/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the demonstration applications of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "plasmadelegate.h"
#include <qabstractitemmodel.h>
#include <qpainter.h>

PlasmaDelegate::PlasmaDelegate(QObject *parent)
    : QAbstractItemDelegate(parent)
{
}

PlasmaDelegate::~PlasmaDelegate()
{

}

void PlasmaDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option,
                           const QAbstractItemModel *model, const QModelIndex &index) const
{
    unsigned char s = option.state & QStyle::Style_Selected ? 63 : 0;
    unsigned int color = model->data(index, QAbstractItemModel::DisplayRole).toInt();
    unsigned char r = ((color & 0x00FF0000) >> 16) + s;
    unsigned char g = ((color & 0x0000FF00) >> 8) + s;
    unsigned char b = (color & 0x000000FF) + s;

    painter->setPen(Qt::NoPen);
    painter->setBrush(QColor(r, g, b));
    painter->drawRect(option.rect);
}

QSize PlasmaDelegate::sizeHint(const QStyleOptionViewItem &,
                               const QAbstractItemModel *,
                               const QModelIndex &) const
{
    return QSize(4, 4);
}
