/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the compatibility classes of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QDEEPCOPY_H
#define QDEEPCOPY_H

#  include "qglobal.h"

#ifdef QT_COMPAT
template <class T>
class QT_COMPAT QDeepCopy
{
public:
    inline QDeepCopy()
    {
    }

    inline QDeepCopy(const T &t)
        : deepcopy(t)
    {
        deepcopy.detach();
    }

    inline QDeepCopy<T> &operator=(const T &t)
    {
        deepcopy = t;
        deepcopy.detach();
        return *this;
    }

    inline operator T ()
    {
        T tmp = deepcopy;
        tmp.detach();
        return tmp;
    }

private:
    T deepcopy;
};
#endif

#endif // QDEEPCOPY_H
