/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the compatibility classes of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QOBJECTDICT_H
#define QOBJECTDICT_H

#include "qmetaobject.h"
#include "qasciidict.h"


//
// The object dictionary is a collection of QMetaObjects
//

class Q_COMPAT_EXPORT QObjectDictionary : public QAsciiDict<QMetaObject>
{
public:
    QObjectDictionary(int size=17,bool cs=true,bool ck=true)
        : QAsciiDict<QMetaObject>(size,cs,ck) {}
    QObjectDictionary(const QObjectDictionary &dict)
        : QAsciiDict<QMetaObject>(dict) {}
   ~QObjectDictionary() { clear(); }
    QObjectDictionary &operator=(const QObjectDictionary &dict)
        { return static_cast<QObjectDictionary&>(QAsciiDict<QMetaObject>::operator=(dict));}
};

#endif // QOBJECTDICT_H
