/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the compatibility classes of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QSORTEDLIST_H
#define QSORTEDLIST_H

#include "qptrlist.h"


template<class type>
class QSortedList : public QPtrList<type>
{
public:
    QSortedList() {}
    QSortedList(const QSortedList<type> &l) : QPtrList<type>(l) {}
    ~QSortedList() { this->clear(); }
    QSortedList<type> &operator=(const QSortedList<type> &l)
      { return static_cast<QSortedList<type> &>(QPtrList<type>::operator=(l)); }

    virtual int compareItems(QPtrCollection::Item s1, QPtrCollection::Item s2) {
        if (*static_cast<type*>(s1) == *static_cast<type*>(s2)) return 0;
        return (*static_cast<type*>(s1) < *static_cast<type*>(s2) ? -1 : 1); }
};

#endif
