/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the painting module of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QBITMAP_H
#define QBITMAP_H

#include "qpixmap.h"


class Q_GUI_EXPORT QBitmap : public QPixmap
{
public:
    QBitmap();
    QBitmap(int w, int h,  bool clear = false,
             QPixmap::Optimization = QPixmap::DefaultOptim);
    QBitmap(const QSize &, bool clear = false,
             QPixmap::Optimization = QPixmap::DefaultOptim);
    QBitmap(int w, int h,  const uchar *bits, bool isXbitmap=false);
    QBitmap(const QSize &, const uchar *bits, bool isXbitmap=false);
    QBitmap(const QBitmap &);
    QBitmap(const QPixmap &);
    QBitmap(const QImage &);
#ifndef QT_NO_IMAGEIO
    QBitmap(const QString &fileName, const char *format=0);
#endif
    QBitmap &operator=(const QBitmap &);
    QBitmap &operator=(const QPixmap &);
    QBitmap &operator=(const QImage  &);

#ifndef QT_NO_PIXMAP_TRANSFORMATION
    QBitmap transform(const QMatrix &) const;
#ifdef QT_COMPAT
    inline QT_COMPAT QBitmap xForm(const QMatrix &matrix) const { return transform(matrix); }
#endif
#endif
};


#endif // QBITMAP_H
