/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the item views module of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QABSTRACTITEMMODEL_P_H
#define QABSTRACTITEMMODEL_P_H

#include <private/qobject_p.h>

class QPersistentModelIndexData
{
public:
    QPersistentModelIndexData() : model(0)
    {
        ref = 0;
    }
    QAbstractItemModel *model;
    QModelIndex index;
    QAtomic ref;
    static QPersistentModelIndexData shared_null;

    static QPersistentModelIndexData *create(const QModelIndex &index, QAbstractItemModel *model);
    static void destroy(QPersistentModelIndexData *data);
};

class QAbstractItemModelPrivate : public QObjectPrivate
{
    Q_DECLARE_PUBLIC(QAbstractItemModel)

public:
    static QString i2s(QChar *buf, int size, int num);
    QList<QPersistentModelIndexData*> persistentIndexes;
};

#endif // QABSTRACTITEMMODEL_P_H
