/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the style module of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QWINDOWSXPSTYLE_H
#define QWINDOWSXPSTYLE_H

#include "qwindowsstyle.h"

#if !defined(QT_NO_STYLE_WINDOWSXP) || defined(QT_PLUGIN)

#if defined(QT_PLUGIN)
#define Q_GUI_EXPORT_STYLE_WINDOWSXP
#else
#define Q_GUI_EXPORT_STYLE_WINDOWSXP Q_GUI_EXPORT
#endif

class QWindowsXPStylePrivate;

class Q_GUI_EXPORT_STYLE_WINDOWSXP QWindowsXPStyle : public QWindowsStyle
{
    Q_OBJECT
public:
    QWindowsXPStyle();
    ~QWindowsXPStyle();

    void unPolish(QApplication*);
    void polish(QApplication*);
    void polish(QWidget*);
    void unPolish(QWidget*);

    void drawPrimitive(PrimitiveElement op,
                        QPainter *p,
                        const QRect &r,
                        const QPalette &pal,
                        SFlags flags = Style_Default
                        /*const Q3StyleOption& = Q3StyleOption::Default*/) const;

    void drawControl(ControlElement element,
                      QPainter *p,
                      const QWidget *widget,
                      const QRect &r,
                      const QPalette &pal,
                      SFlags how = Style_Default
                      /*const Q3StyleOption& = Q3StyleOption::Default*/) const;

    void drawControlMask(ControlElement element,
                          QPainter *p,
                          const QWidget *widget,
                          const QRect &r
                          /*const Q3StyleOption& = Q3StyleOption::Default*/) const;

    void drawComplexControl(ComplexControl control,
                             QPainter* p,
                             const QWidget* w,
                             const QRect& r,
                             const QPalette &pal,
                             SFlags flags = Style_Default,
                             SCFlags sub = SC_All,
                             SCFlags subActive = SC_None
                             /*const Q3StyleOption& = Q3StyleOption::Default*/) const;


    int pixelMetric(PixelMetric metic, const QStyleOption *option = 0, const QWidget *widget = 0) const;

    QRect querySubControlMetrics(ComplexControl control,
                                 const QWidget *widget,
                                 SubControl sc
                                 /*const Q3StyleOption& = Q3StyleOption::Default*/) const;

    QSize sizeFromContents(ContentsType contents, const QWidget *widget,
                           const QSize &contentsSize
                           /*const Q3StyleOption& = Q3StyleOption::Default*/) const;

    int styleHint(StyleHint stylehint, const QWidget *widget = 0,
                  /*const Q3StyleOption& = Q3StyleOption::Default, */
                  QStyleHintReturn *returnData = 0) const;

protected:
    bool eventFilter(QObject *o, QEvent *e);

    void updateRegion(QWidget *widget);

protected slots:
    void activeTabChanged();

private:
    Q_DISABLE_COPY(QWindowsXPStyle)

    QWindowsXPStylePrivate *d;

    friend class QStyleFactory;
    friend class QWindowsXPStylePrivate;
    static bool resolveSymbols();
};

#endif // QT_NO_STYLE_WINDOWSXP

#endif // QWINDOWSXPSTYLE_H
