/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the embedded classes of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include <qdecorationplugin_qws.h>
#include <qdecorationhydro_qws.h>

class DecorationHydro : public QDecorationPlugin
{
public:
    DecorationHydro();

    QStringList keys() const;
    QDecoration *create(const QString&);
};

DecorationHydro::DecorationHydro()
: QDecorationPlugin()
{
}

QStringList DecorationHydro::keys() const
{
    QStringList list;
    list << "Hydro";
    return list;
}

QDecoration* DecorationHydro::create(const QString& s)
{
    if (s.toLower() == "hydro")
        return new QDecorationHydro();

    return 0;
}

Q_EXPORT_PLUGIN(DecorationHydro)
